
%   Une version discrete du modele de reaction chimique connu
%   sous le nom de BRUSSELATOR est annalyse ici.
%   references : le livre de Seydel (parctical bifurcation ...) 
%   chapitre 5 page 188
%
%   les equations de depart sont
%
%   2 - 7u1       + u1*u1*u2  +    lambda(u3-u1)     =0
%       6u1       - u1*u1*u2  + 10 lambda(u4-u2)     =0
%   2 - 7u3       + u3*u3*u4  +    lambda(u1+u5-2u3) =0
%       6u3       - u3*u3*u4  + 10 lambda(u2+u6-2u4) =0
%   2 - 7u5       + u5*u5*u6  +    lambda(u3-u5)     =0
%       6u5       - u5*u5*u6  + 10 lambda(u4+u6)     =0
%
%  On met sous forme quadratique tres facilement en posant
%      u7=u1*u1
%      u8=u3*u3
%      u9=u5*u5
%
%  ce qui fait un pb a 9 equations et 10 inconnues
%
%  on a   U=[ u1  u2 ....  u9 lambda]  
 
 manlabinit;
 
 a=0;
 ML_problem  = BRUSSELATOR(a); % creation de l' objet 
 


 %ML_Ustart   = [2   3   2  3  2  3   4  4  4   2  ]';   % definition d'un vecteur solution approchee
 ML_Ustart   = [ 2.89   2.63   1.86   2.75   1.23   2.84  8.36  3.48 1.53 3.67 ]';
 
 ML_dispvars = [  10   1  ];     % definition d'un vecteur contenant les index 
                                     % des variables a afficher (x,y)
 manlabstart; 


