
%function dx=ressort(t,x,alpha,Omega)
function dx=ressort(t,x)

% equation du mouvement pour le modele a deux ressorts 
% -----------------------------------------------------
%
% OM1car et OM2car  carre des pulsations propres linaires 
%
% alpha :  parametre de linarite   alpha=0 -> linaire   
%                                  alpha=1 -> non linaire geometrique
%
%  c    :  coefficient d'amortissement
%
%  f1, f2 : forcing  
%  Omega  : pulsation du forcing 
%

OM1car=1;
OM2car=2;
%
alpha=1;
%
c= 0.;
%
Omega=0;
f1=0.;
f2=0.;
%;
%
enl=(x(1)*x(1)+x(2)*x(2))*0.5*alpha;
N1=OM1car*(x(1) + enl);
N2=OM2car*(x(2) + enl);
% equation du mouvement
dx(1)= x(3);
dx(2)= x(4);
dx(3)=-N1*(1+x(1)*alpha)-N2*x(1)*alpha    - c*x(3) + f1*cos(Omega*t);
dx(4)=-N1*x(2)*alpha    -N2*(1+x(2)*alpha)- c*x(4) + f2*cos(Omega*t);
dx=dx(:);




