function [Ups,FpnlA] = calculeseries(sys,Uo,Utj)


% Matrice tangente systeme au point de depart
dRdU = get_dRdU(sys,Uo);

% Vecteur tangent exact a la branche au point de depart
U1 = tangente(sys,dRdU,Uo);


if (U1'*Utj) <0
  U1 = - U1;
end


% Matrice tangente de la MAN
K = [dRdU ; (get_chemin(sys).*U1)'];
invK = inv(K);


%                 
% Premier Ordre   
%                 

Ups = U1;

%                 
% Ordres suivants 
%                 

for p=2:get_ordre(sys)

    Fpnl = zeros(get_neq(sys),1);  
      
    for r=1:p-1
      Fpnl = Fpnl - Q(sys,Ups(:,r),Ups(:,p-r));
    end

    Fpnl = [Fpnl ; 0]; 

    Ups = [Ups  invK*Fpnl];
                        % Pour p=2 on a U1 et U2 dans Ups     
end


% on calcule le second membre supplementaire
   Fpnl = zeros(get_neq(sys),1);  
      
    for r=1:p
      Fpnl = Fpnl - Q(sys,Ups(:,r),Ups(:,p+1-r));
    end

FpnlA = Fpnl  ;

Ups = [Uo Ups];


