
      SUBROUTINE EVE_TANGENTE(NOMFICH,
     *                        C0,U0,SIG0,Ci,Ui,SIGi,FQi)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                %
COMM %   Calcul de la tangente au point de depart C0,U0, SIG0         %
COMM %                                                                %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
      INCLUDE "tableau.f"
      INTEGER  NORDRE
      CHARACTER*20 NOMFICH 
      DOUBLE PRECISION XL
      
      OPEN(UNIT=5,FILE=NOMFICH,STATUS='OLD',ACCESS='SEQUENTIAL')  
COMM ..................................................................
COMM //////       Lecture des données dans le fichier clé       //////
COMM ..................................................................
      CALL DONNEE(COOR,MAIL,EMAI,EPAI,LIAI,DFOR,DREL,ICO,MAXNOE,MAXELE)
      CLOSE(5)
COMM ..................................................................      
COMM ......../////  reprise des valeurs entières dans ICO  ///////....... 
COMM ..................................................................     
      KTYP =ICO(1)
      NCPN =ICO(2)
      NDPN =ICO(3)
      NNPE =ICO(4)
      NSPG =ICO(5)            
      NNOE =ICO(6)
      NDL  =ICO(7)
      NMAI =ICO(8)
      NVMA =ICO(10)
      NLIAI=ICO(11)
      NVF1 =ICO(13)
      IF(KTYP.EQ.1.OR.KTYP.EQ.2.OR.KTYP.EQ.3) THEN ! Elasticite 2D
        NTPG=4
      ELSE IF(KTYP.EQ.4) THEN                      ! Elasticite 3D
        NTPG=9 
      ELSE IF(KTYP.EQ.5) THEN                      ! Coques 
        NTPG=2       
      ELSE
       STOP ' Pb KTYP ANMCA2 '
      ENDIF                        
COMM ..................................................................  
COMM .....//// Profil de K, nombre de termes de K et de S ////......
COMM  ..................................................................  
      CALL PROFBI(IDIA,MAIL,NDL,NMAI,NRIG,NNPE,NDPN,KTYP)
      ICO(26)=NRIG
      CALL LONSIG(MAIL,NMAI,NNPE,NSPG,NSIG,NEPS,KTYP)
      ICO(27)=NSIG
      NTET=(NSIG/NSPG)*NTPG  
COMM ..................................................................  
COMM ..........//// vecteur des forces exterieures  ////......
COMM  ..................................................................                               
      CALL CAFORC(DFOR,F,ICO)
      
       XL=1.D0
       NORDRE=2
       CALL SERIES(COOR,MAIL,EMAI,EPAI,LIAI,
     *             IDIA,F,RIG,C0,U0,SIG0,
     *             Ci,Ui,SIGi,Ti,FQi,XL,
     *             NNOE,NMAI,NDL,NCPN,NDPN,NNPE,NLIAI,
     *             NVMA,KTYP,NSPG,NTPG,NSIG,NTET,NORDRE,ICO)       
       END
       

      
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                %
COMM %   The gateway routine                                          %
COMM %                                                                %
COMM %   [Ci,Ui,SIGi,FQi]=EVE_CALCUL_SERIES('nom fichier.cle',NORDRE, %
COMM %                                       C0,U0,SIG0)              %                                                             %
COMM %                                                                %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                 
      
      subroutine mexFunction(nlhs, plhs, nrhs, prhs)
C--------------------------------------------------------------
      INCLUDE "tableau.f"
      
      integer plhs(*), prhs(*)
      integer nlhs, nrhs
      
      integer  status, strlen
            
      integer mU, nU, sizeU, mSIG, nSIG, sizeSIG
      
      integer mxGetM, mxGetN, mxIsNumeric, mxIsChar
      integer mxCreateString, mxGetString
      integer mxCreateDoubleMatrix  
          
      integer C0_pr,U0_pr,SIG0_pr,Ci_pr,Ui_pr,SIGi_pr,FQi_pr
      
c-----Declaration des variables Fortran-----
      character*20 NOMFICH
      
      
C     Check for proper number of arguments. 
      if (nrhs .ne. 4) then
         call mexErrMsgTxt('4 arguments demandes en entre')
      elseif (nlhs .ne. 3) then
         call mexErrMsgTxt('3 argument demandes en sortie') 
	 
C     The first input  must be a string.
      elseif(mxIsChar(prhs(1)) .ne. 1) then
         call mexErrMsgTxt('Input must be a string.')

C     The input must be a row vector.
      elseif (mxGetM(prhs(1)) .ne. 1) then
         call mexErrMsgTxt('Input must be a row vector.')
      endif
    
C     Get the length of the input string.
      strlen = mxGetM(prhs(1))*mxGetN(prhs(1))

C     Get the string contents (dereference the input integer).
      status = mxGetString(prhs(1), NOMFICH, 20)

C     Check if mxGetString is successful.
      if (status .ne. 0) then 
         call mexErrMsgTxt('Nom de fichier trop long (20 max)')
      endif
   
          
C-----traitement des arguments suivants
C     taille de U0 et SIG0

      mU = mxGetM(prhs(3))
      nU = mxGetN(prhs(3))
      sizeU = mU*nU           
      mSIG = mxGetM(prhs(4))
      nSIG = mxGetN(prhs(4))
      sizeSIG = mSIG*nSIG          
      
      
C     Create matrix for the return argument.
      plhs(1) = mxCreateDoubleMatrix(1   , 1    , 0)
      plhs(2) = mxCreateDoubleMatrix(mU  , nU   , 0)      
      plhs(3) = mxCreateDoubleMatrix(mSIG, nSIG , 0)      
 

C-----pointeur pour les arguments d'entre  puis de sortie  
      C0_pr     = mxGetPr(prhs(2))      
      U0_pr     = mxGetPr(prhs(3))
      SIG0_pr   = mxGetPr(prhs(4)) 
      
      Ci_pr     = mxGetPr(plhs(1))      
      Ui_pr     = mxGetPr(plhs(2))
      SIGi_pr   = mxGetPr(plhs(3)) 
      
C     Load the data into Fortran arrays.
      call mxCopyPtrToReal8(C0_pr, C0, 1)
      call mxCopyPtrToReal8(U0_pr, U0, sizeU)
      call mxCopyPtrToReal8(SIG0_pr, SIG0, sizeSIG)            
      
C     Call the computational subroutine.
      call EVE_TANGENTE(NOMFICH,
     *                  C0,U0,SIG0,Ci,Ui,SIGi,FQi)
     
C     Load the output into a MATLAB array.
      call mxCopyReal8ToPtr(Ci, Ci_pr, 1)
      call mxCopyReal8ToPtr(Ui, Ui_pr, sizeU)      
      call mxCopyReal8ToPtr(SIGi, SIGi_pr, sizeSIG)                 
      return
      end
