COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %          EVE  Version Manlab   (B. Cochelin Avril 2005)         %
COMM %                                                                 %
COMM %           Origine : EVE   Version 2.1  (Novembre 94)            %                
COMM %                                                                 %
COMM %       //////  MODULE PILOTE DU CALCUL ELASTIQUE   //////        %
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      SUBROUTINE ELASTI(COOR,MAIL,EMAI,EPAI,LIAI,DFOR,DREL,ICO,
     *                  IDIA,RIG,F,U,SIG)    
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %              CALCUL ELASTIQUE DE LA STRUCTURE                   %
COMM %               POUR LES DIFFERENTS CHARGEMENTS                   %
COMM %                                                                 %
COMM %                                                                 %
COMM %   IDIA       Pointeurs de la diagonale       (ENTIER)           %
COMM %   Fi         vecteur de chargement           (DP)               %
COMM %   RIG        Matrice de rigidite             (DP)               %
COMM %   U          Vecteur deplacement             (DP)               %
COMM %   SIG        Contraintes aux points de Gauss (DP)               %            %
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      INTEGER          ICO(50)

      DOUBLE PRECISION COOR(*)
      INTEGER          MAIL(*)
      DOUBLE PRECISION EMAI(*)
      DOUBLE PRECISION EPAI(*)
      INTEGER          LIAI(*)
      REAL             DFOR(*)
      REAL             DREL(*)

      INTEGER          IDIA(*)
      DOUBLE PRECISION RIG(*)
      DOUBLE PRECISION F(*)
      DOUBLE PRECISION U(*)
      DOUBLE PRECISION SIG(*)

 
COMM .............../////  reprise des valeurs entires dans ICO  ///////.............
      KTYP =ICO(1)
      NCPN =ICO(2)
      NDPN =ICO(3)
      NNPE =ICO(4)      
      NSPG =ICO(5)      
      NDL  =ICO(7)
      NMAI =ICO(8)
      NVMA =ICO(10)
      NCHA =ICO(12)
      NLIAI=ICO(11)
      NRELA=ICO(24)
COMM
COMM .....//// Profil de K, nombre de termes de K et de S ////......
COMM 
      CALL PROFBI(IDIA,MAIL,NDL,NMAI,NRIG,NNPE,NDPN,KTYP)
      ICO(26)=NRIG
      CALL LONSIG(MAIL,NMAI,NNPE,NSPG,NSIG,NEPS,KTYP)
      ICO(27)=NSIG
      ICO(28)=NEPS
COMM            
COMM .../// ASSEMBLAGE DE LA MATRICE DE RIGIDITE , PRISE EN COMPTE //..
COMM .../// DES BLOCAGES, ET DECOMPOSITION                         //..
COMM
      CALL RIGELA(RIG,IDIA,COOR,MAIL,EMAI,EPAI,
     *            NMAI,NDL,NCPN,NDPN,NNPE,NVMA,KTYP)   
      CALL CALIRI(RIG,IDIA,LIAI,NLIAI,NDPN,NDL)
      
      CALL DECCHO(RIG,IDIA,NDL,0)
COMM
COMM ...////// POUR CHAQUE CHARGEMENT ON RESOUD   ///////.............. 
COMM     
      IAD=0
      DO 6 IC=1,NCHA
       CALL CAFORC(DFOR(1+IAD),F,ICO)
       CALL SHIFTD(F,U,NDL)
       CALL CALIMP(LIAI,U,NLIAI,NDPN)
       CALL RESCHO(RIG,U,IDIA,NDL)
       CALL DZERO(SIG,NSIG)   
       CALL SIGELA(SIG,U,COOR,MAIL,EMAI,
     *             EPAI,NMAI,NCPN,NDPN,NNPE,NVMA,KTYP)
       CALL IMPTCH(IC)
       CALL IMPELA(U,SIG,MAIL,ICO)
       IAD=IAD+ICO(12+IC)
 6    CONTINUE
COMM ..................../////////////................................      
 150  FORMAT(////////,
     ;'  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%',/,
     ;'  %                                                        %',/, 
     ;'  %         CALCUL   ELASTIQUE   LINEAIRE                  %',/,      
     ;'  %                                                        %',/,      
     ;'  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')           
 100  FORMAT('1',//,' ',60('%'),///,
     ;'  ORGANISATION DU SUPER-TABLEAU  T() ',//)
 110  FORMAT(' ',60('%'),/////)
 120  FORMAT('   IT(',I3,')=',I8,'     Longueur=',I8)
 130  FORMAT(///,'   Taille memoire necessaire   : ',I8,/,
     ;           '   Dimension du Super-Tableau  : ',I8,///)      
      END

COMM ...........................////////////...........................
COMM ...........////// FIN DU MODULE PILOTE DE CALCUL //////...........
COMM ...........//////           ELASTIQUE            //////...........
COMM ...........................////////////...........................
